using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Text.RegularExpressions;

namespace TS_analyzer
{
	public class info : System.Windows.Forms.Form
	{
        public static int MyBuffer = 1000;
        public double fps30 = 1/(30.0 / 1.001);
        public double ac3 = .032;
        public string audio_extension = "ac3";
        //        public static double ac3 = .02133;
        public double fps30_total;
        public double ac3_total;
        public bool ac3_off = false;
        public double ac3_adjusted = 0.00;
        public long PTS33;
        public double PTS;
        public long DTS33;
        public double DTS;

        #region FormJunk
        private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label pack_no;
		private System.Windows.Forms.TextBox error;
		private System.Windows.Forms.TextBox pes_st;
		private System.Windows.Forms.TextBox pid;
		private System.Windows.Forms.TextBox ad;
		private System.Windows.Forms.TextBox payload;
		private System.Windows.Forms.TextBox cnt;
		private System.Windows.Forms.TextBox ad_len;
		private System.Windows.Forms.TextBox pcr;
		private System.Windows.Forms.TextBox pcr_val;
		private System.Windows.Forms.TextBox pay_len;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.TextBox textBox3;
		private System.Windows.Forms.TextBox textBox4;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.TextBox textBox5;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label t1;
		private System.Windows.Forms.Button next;
		private System.Windows.Forms.Button back;
		private System.Windows.Forms.Label t2;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Button write;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Button go;
		private System.Windows.Forms.Label t3;
		private System.Windows.Forms.Label pack_tot;
        #endregion

        public ts_info[] data=new ts_info[MyBuffer];	// TS packets Buffer
        public ts_info[] ac3_unit = new ts_info[20];     // Hold an ac3 unit for padding
        public long pack_nr;	// Curent packet
		public FileStream file; // Input stream
		public string f_name; // Input stream file name
		public long max;	// File size in bytes
		public long poz;	// Curent index in bytes readed
		public byte[] rd=new Byte[188]; // Raw data
		public long nr_packs;
		private System.Windows.Forms.TextBox jump;	// number of packets
		public ts_analyzer my_ts;
		private System.Windows.Forms.Button stats;
		private System.Windows.Forms.Button button1;
        private TextBox PIDTextBox;
        private TextBox CountTextBox;
        private TextBox PacketLenTextBox;
        private TextBox PCRTextBox;
        private Button PrevPESButton;
        private Button NextPESButton;
        private TextBox CurrentPositionTextBox;
        private Button button2;
        private Button CutSection;
        private RichTextBox HextextBox;
        private RichTextBox ErrorTextBox;
        private ComboBox comboBox1;
        private ComboBox comboBox2;

		private System.ComponentModel.Container components = null;

		public info()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				my_ts.Show();
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(info));
            this.label1 = new System.Windows.Forms.Label();
            this.pack_no = new System.Windows.Forms.Label();
            this.error = new System.Windows.Forms.TextBox();
            this.pes_st = new System.Windows.Forms.TextBox();
            this.pid = new System.Windows.Forms.TextBox();
            this.ad = new System.Windows.Forms.TextBox();
            this.payload = new System.Windows.Forms.TextBox();
            this.cnt = new System.Windows.Forms.TextBox();
            this.ad_len = new System.Windows.Forms.TextBox();
            this.pcr = new System.Windows.Forms.TextBox();
            this.pcr_val = new System.Windows.Forms.TextBox();
            this.pay_len = new System.Windows.Forms.TextBox();
            this.label2 = new System.Windows.Forms.Label();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.textBox2 = new System.Windows.Forms.TextBox();
            this.textBox3 = new System.Windows.Forms.TextBox();
            this.textBox4 = new System.Windows.Forms.TextBox();
            this.label3 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.next = new System.Windows.Forms.Button();
            this.back = new System.Windows.Forms.Button();
            this.textBox5 = new System.Windows.Forms.TextBox();
            this.label7 = new System.Windows.Forms.Label();
            this.label8 = new System.Windows.Forms.Label();
            this.label9 = new System.Windows.Forms.Label();
            this.t1 = new System.Windows.Forms.Label();
            this.t2 = new System.Windows.Forms.Label();
            this.button3 = new System.Windows.Forms.Button();
            this.label10 = new System.Windows.Forms.Label();
            this.pack_tot = new System.Windows.Forms.Label();
            this.write = new System.Windows.Forms.Button();
            this.label12 = new System.Windows.Forms.Label();
            this.jump = new System.Windows.Forms.TextBox();
            this.go = new System.Windows.Forms.Button();
            this.t3 = new System.Windows.Forms.Label();
            this.stats = new System.Windows.Forms.Button();
            this.button1 = new System.Windows.Forms.Button();
            this.PIDTextBox = new System.Windows.Forms.TextBox();
            this.CountTextBox = new System.Windows.Forms.TextBox();
            this.PacketLenTextBox = new System.Windows.Forms.TextBox();
            this.PCRTextBox = new System.Windows.Forms.TextBox();
            this.PrevPESButton = new System.Windows.Forms.Button();
            this.NextPESButton = new System.Windows.Forms.Button();
            this.CurrentPositionTextBox = new System.Windows.Forms.TextBox();
            this.button2 = new System.Windows.Forms.Button();
            this.CutSection = new System.Windows.Forms.Button();
            this.HextextBox = new System.Windows.Forms.RichTextBox();
            this.ErrorTextBox = new System.Windows.Forms.RichTextBox();
            this.comboBox1 = new System.Windows.Forms.ComboBox();
            this.comboBox2 = new System.Windows.Forms.ComboBox();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(333, 7);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(104, 16);
            this.label1.TabIndex = 0;
            this.label1.Text = "TS Pack number :";
            // 
            // pack_no
            // 
            this.pack_no.AutoSize = true;
            this.pack_no.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.pack_no.Location = new System.Drawing.Point(512, 7);
            this.pack_no.Name = "pack_no";
            this.pack_no.Size = new System.Drawing.Size(0, 13);
            this.pack_no.TabIndex = 1;
            // 
            // error
            // 
            this.error.Location = new System.Drawing.Point(8, 48);
            this.error.Name = "error";
            this.error.ReadOnly = true;
            this.error.Size = new System.Drawing.Size(32, 20);
            this.error.TabIndex = 2;
            this.error.Text = "Error";
            this.error.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            this.error.MouseEnter += new System.EventHandler(this.see_error);
            // 
            // pes_st
            // 
            this.pes_st.Location = new System.Drawing.Point(40, 48);
            this.pes_st.Name = "pes_st";
            this.pes_st.ReadOnly = true;
            this.pes_st.Size = new System.Drawing.Size(56, 20);
            this.pes_st.TabIndex = 3;
            this.pes_st.Text = "PES start";
            this.pes_st.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            this.pes_st.MouseEnter += new System.EventHandler(this.see_pes_st);
            // 
            // pid
            // 
            this.pid.Location = new System.Drawing.Point(96, 48);
            this.pid.Name = "pid";
            this.pid.ReadOnly = true;
            this.pid.Size = new System.Drawing.Size(32, 20);
            this.pid.TabIndex = 4;
            this.pid.Text = "PID";
            this.pid.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            this.pid.MouseEnter += new System.EventHandler(this.see_pid);
            // 
            // ad
            // 
            this.ad.Location = new System.Drawing.Point(128, 48);
            this.ad.Name = "ad";
            this.ad.ReadOnly = true;
            this.ad.Size = new System.Drawing.Size(48, 20);
            this.ad.TabIndex = 5;
            this.ad.Text = "Ad. Field";
            this.ad.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            this.ad.MouseEnter += new System.EventHandler(this.see_ad);
            // 
            // payload
            // 
            this.payload.Location = new System.Drawing.Point(176, 48);
            this.payload.Name = "payload";
            this.payload.ReadOnly = true;
            this.payload.Size = new System.Drawing.Size(48, 20);
            this.payload.TabIndex = 6;
            this.payload.Text = "Payload";
            this.payload.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            this.payload.MouseEnter += new System.EventHandler(this.see_pay);
            // 
            // cnt
            // 
            this.cnt.Location = new System.Drawing.Point(224, 48);
            this.cnt.Name = "cnt";
            this.cnt.ReadOnly = true;
            this.cnt.Size = new System.Drawing.Size(48, 20);
            this.cnt.TabIndex = 7;
            this.cnt.Text = "Counter";
            this.cnt.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            this.cnt.MouseEnter += new System.EventHandler(this.see_cnt);
            // 
            // ad_len
            // 
            this.ad_len.Location = new System.Drawing.Point(272, 48);
            this.ad_len.Name = "ad_len";
            this.ad_len.ReadOnly = true;
            this.ad_len.Size = new System.Drawing.Size(64, 20);
            this.ad_len.TabIndex = 8;
            this.ad_len.Text = "Ad. Length";
            this.ad_len.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            this.ad_len.MouseEnter += new System.EventHandler(this.see_ad_len);
            // 
            // pcr
            // 
            this.pcr.Location = new System.Drawing.Point(336, 48);
            this.pcr.Name = "pcr";
            this.pcr.ReadOnly = true;
            this.pcr.Size = new System.Drawing.Size(64, 20);
            this.pcr.TabIndex = 9;
            this.pcr.Text = "PCR Flag";
            this.pcr.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            this.pcr.MouseEnter += new System.EventHandler(this.see_pcr);
            // 
            // pcr_val
            // 
            this.pcr_val.Location = new System.Drawing.Point(400, 48);
            this.pcr_val.Name = "pcr_val";
            this.pcr_val.ReadOnly = true;
            this.pcr_val.Size = new System.Drawing.Size(64, 20);
            this.pcr_val.TabIndex = 10;
            this.pcr_val.Text = "PCR value";
            this.pcr_val.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            this.pcr_val.MouseEnter += new System.EventHandler(this.see_pcr_val);
            // 
            // pay_len
            // 
            this.pay_len.Location = new System.Drawing.Point(464, 48);
            this.pay_len.Name = "pay_len";
            this.pay_len.ReadOnly = true;
            this.pay_len.Size = new System.Drawing.Size(80, 20);
            this.pay_len.TabIndex = 11;
            this.pay_len.Text = "Payload Length";
            this.pay_len.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            this.pay_len.MouseEnter += new System.EventHandler(this.see_pay_len);
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(16, 88);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(56, 16);
            this.label2.TabIndex = 12;
            this.label2.Text = "Legend :";
            // 
            // textBox1
            // 
            this.textBox1.BackColor = System.Drawing.Color.Lime;
            this.textBox1.Location = new System.Drawing.Point(8, 104);
            this.textBox1.Name = "textBox1";
            this.textBox1.ReadOnly = true;
            this.textBox1.Size = new System.Drawing.Size(16, 20);
            this.textBox1.TabIndex = 13;
            this.textBox1.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            // 
            // textBox2
            // 
            this.textBox2.BackColor = System.Drawing.Color.Magenta;
            this.textBox2.Location = new System.Drawing.Point(8, 125);
            this.textBox2.Name = "textBox2";
            this.textBox2.ReadOnly = true;
            this.textBox2.Size = new System.Drawing.Size(16, 20);
            this.textBox2.TabIndex = 14;
            this.textBox2.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            // 
            // textBox3
            // 
            this.textBox3.BackColor = System.Drawing.Color.Aqua;
            this.textBox3.Location = new System.Drawing.Point(8, 144);
            this.textBox3.Name = "textBox3";
            this.textBox3.ReadOnly = true;
            this.textBox3.Size = new System.Drawing.Size(16, 20);
            this.textBox3.TabIndex = 15;
            this.textBox3.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            // 
            // textBox4
            // 
            this.textBox4.BackColor = System.Drawing.Color.Silver;
            this.textBox4.Location = new System.Drawing.Point(8, 164);
            this.textBox4.Name = "textBox4";
            this.textBox4.ReadOnly = true;
            this.textBox4.Size = new System.Drawing.Size(16, 20);
            this.textBox4.TabIndex = 16;
            this.textBox4.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(29, 108);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(32, 16);
            this.label3.TabIndex = 17;
            this.label3.Text = "True";
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(30, 128);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(32, 16);
            this.label4.TabIndex = 18;
            this.label4.Text = "False";
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(30, 147);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(34, 16);
            this.label5.TabIndex = 19;
            this.label5.Text = "Exists";
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(30, 168);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(58, 16);
            this.label6.TabIndex = 20;
            this.label6.Text = "Not exists";
            // 
            // next
            // 
            this.next.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(224)))), ((int)(((byte)(224)))), ((int)(((byte)(224)))));
            this.next.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.next.Location = new System.Drawing.Point(264, 16);
            this.next.Name = "next";
            this.next.Size = new System.Drawing.Size(24, 24);
            this.next.TabIndex = 21;
            this.next.Text = ">";
            this.next.UseVisualStyleBackColor = false;
            this.next.Click += new System.EventHandler(this.next_Click);
            // 
            // back
            // 
            this.back.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(224)))), ((int)(((byte)(224)))), ((int)(((byte)(224)))));
            this.back.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.back.Location = new System.Drawing.Point(64, 16);
            this.back.Name = "back";
            this.back.Size = new System.Drawing.Size(24, 24);
            this.back.TabIndex = 22;
            this.back.Text = "<";
            this.back.UseVisualStyleBackColor = false;
            this.back.Click += new System.EventHandler(this.button2_Click);
            // 
            // textBox5
            // 
            this.textBox5.BackColor = System.Drawing.Color.Yellow;
            this.textBox5.Location = new System.Drawing.Point(8, 184);
            this.textBox5.Name = "textBox5";
            this.textBox5.ReadOnly = true;
            this.textBox5.Size = new System.Drawing.Size(16, 20);
            this.textBox5.TabIndex = 23;
            this.textBox5.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            // 
            // label7
            // 
            this.label7.Location = new System.Drawing.Point(30, 187);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(98, 16);
            this.label7.TabIndex = 24;
            this.label7.Text = "Determined value";
            // 
            // label8
            // 
            this.label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label8.Location = new System.Drawing.Point(328, 96);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(112, 16);
            this.label8.TabIndex = 25;
            this.label8.Text = "Packet  Field  Info :";
            // 
            // label9
            // 
            this.label9.Location = new System.Drawing.Point(224, 112);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(328, 16);
            this.label9.TabIndex = 26;
            this.label9.Text = "( Move the mouse over the desired field above to see more info )";
            // 
            // t1
            // 
            this.t1.AutoSize = true;
            this.t1.Location = new System.Drawing.Point(256, 136);
            this.t1.Name = "t1";
            this.t1.Size = new System.Drawing.Size(0, 13);
            this.t1.TabIndex = 27;
            // 
            // t2
            // 
            this.t2.AutoSize = true;
            this.t2.Location = new System.Drawing.Point(256, 160);
            this.t2.Name = "t2";
            this.t2.Size = new System.Drawing.Size(0, 13);
            this.t2.TabIndex = 28;
            // 
            // button3
            // 
            this.button3.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(224)))), ((int)(((byte)(224)))), ((int)(((byte)(224)))));
            this.button3.Cursor = System.Windows.Forms.Cursors.Default;
            this.button3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.button3.Location = new System.Drawing.Point(464, 232);
            this.button3.Name = "button3";
            this.button3.Size = new System.Drawing.Size(64, 24);
            this.button3.TabIndex = 29;
            this.button3.Text = "EXIT";
            this.button3.UseVisualStyleBackColor = false;
            this.button3.Click += new System.EventHandler(this.button3_Click);
            // 
            // label10
            // 
            this.label10.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label10.Location = new System.Drawing.Point(328, 24);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(144, 16);
            this.label10.TabIndex = 30;
            this.label10.Text = "Total number of packets :";
            // 
            // pack_tot
            // 
            this.pack_tot.AutoSize = true;
            this.pack_tot.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.pack_tot.Location = new System.Drawing.Point(480, 24);
            this.pack_tot.Name = "pack_tot";
            this.pack_tot.Size = new System.Drawing.Size(0, 13);
            this.pack_tot.TabIndex = 32;
            // 
            // write
            // 
            this.write.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(224)))), ((int)(((byte)(224)))), ((int)(((byte)(224)))));
            this.write.Cursor = System.Windows.Forms.Cursors.Default;
            this.write.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.write.Location = new System.Drawing.Point(24, 240);
            this.write.Name = "write";
            this.write.Size = new System.Drawing.Size(144, 24);
            this.write.TabIndex = 33;
            this.write.Text = "Create Synced AC3";
            this.write.UseVisualStyleBackColor = false;
            this.write.Click += new System.EventHandler(this.write_Click);
            // 
            // label12
            // 
            this.label12.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label12.Location = new System.Drawing.Point(200, 236);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(112, 16);
            this.label12.TabIndex = 34;
            this.label12.Text = "Jump to packet no :";
            // 
            // jump
            // 
            this.jump.BackColor = System.Drawing.Color.Yellow;
            this.jump.Location = new System.Drawing.Point(312, 232);
            this.jump.Name = "jump";
            this.jump.Size = new System.Drawing.Size(72, 20);
            this.jump.TabIndex = 35;
            this.jump.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            // 
            // go
            // 
            this.go.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(224)))), ((int)(((byte)(224)))), ((int)(((byte)(224)))));
            this.go.Cursor = System.Windows.Forms.Cursors.Default;
            this.go.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.go.Location = new System.Drawing.Point(397, 231);
            this.go.Name = "go";
            this.go.Size = new System.Drawing.Size(32, 24);
            this.go.TabIndex = 36;
            this.go.Text = "GO";
            this.go.UseVisualStyleBackColor = false;
            this.go.Click += new System.EventHandler(this.go_Click);
            // 
            // t3
            // 
            this.t3.AutoSize = true;
            this.t3.Location = new System.Drawing.Point(256, 184);
            this.t3.Name = "t3";
            this.t3.Size = new System.Drawing.Size(0, 13);
            this.t3.TabIndex = 37;
            // 
            // stats
            // 
            this.stats.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(224)))), ((int)(((byte)(224)))), ((int)(((byte)(224)))));
            this.stats.Cursor = System.Windows.Forms.Cursors.Default;
            this.stats.Enabled = false;
            this.stats.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.stats.Location = new System.Drawing.Point(24, 213);
            this.stats.Name = "stats";
            this.stats.Size = new System.Drawing.Size(144, 24);
            this.stats.TabIndex = 38;
            this.stats.Text = "Write statistics  to file";
            this.stats.UseVisualStyleBackColor = false;
            this.stats.Visible = false;
            this.stats.Click += new System.EventHandler(this.stats_Click);
            // 
            // button1
            // 
            this.button1.Enabled = false;
            this.button1.Location = new System.Drawing.Point(464, 72);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(72, 24);
            this.button1.TabIndex = 39;
            this.button1.Text = "EXTRACT";
            this.button1.Visible = false;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // PIDTextBox
            // 
            this.PIDTextBox.Location = new System.Drawing.Point(96, 75);
            this.PIDTextBox.Name = "PIDTextBox";
            this.PIDTextBox.Size = new System.Drawing.Size(40, 20);
            this.PIDTextBox.TabIndex = 40;
            // 
            // CountTextBox
            // 
            this.CountTextBox.Location = new System.Drawing.Point(224, 74);
            this.CountTextBox.Name = "CountTextBox";
            this.CountTextBox.Size = new System.Drawing.Size(48, 20);
            this.CountTextBox.TabIndex = 41;
            // 
            // PacketLenTextBox
            // 
            this.PacketLenTextBox.Location = new System.Drawing.Point(464, 74);
            this.PacketLenTextBox.Name = "PacketLenTextBox";
            this.PacketLenTextBox.Size = new System.Drawing.Size(76, 20);
            this.PacketLenTextBox.TabIndex = 42;
            // 
            // PCRTextBox
            // 
            this.PCRTextBox.Location = new System.Drawing.Point(385, 72);
            this.PCRTextBox.Name = "PCRTextBox";
            this.PCRTextBox.Size = new System.Drawing.Size(73, 20);
            this.PCRTextBox.TabIndex = 43;
            // 
            // PrevPESButton
            // 
            this.PrevPESButton.Location = new System.Drawing.Point(93, 17);
            this.PrevPESButton.Name = "PrevPESButton";
            this.PrevPESButton.Size = new System.Drawing.Size(43, 23);
            this.PrevPESButton.TabIndex = 44;
            this.PrevPESButton.Text = "<<";
            this.PrevPESButton.UseVisualStyleBackColor = true;
            this.PrevPESButton.Click += new System.EventHandler(this.PrevPESButton_Click);
            // 
            // NextPESButton
            // 
            this.NextPESButton.Location = new System.Drawing.Point(203, 17);
            this.NextPESButton.Name = "NextPESButton";
            this.NextPESButton.Size = new System.Drawing.Size(42, 23);
            this.NextPESButton.TabIndex = 45;
            this.NextPESButton.Text = ">>";
            this.NextPESButton.UseVisualStyleBackColor = true;
            this.NextPESButton.Click += new System.EventHandler(this.NextPESButton_Click);
            // 
            // CurrentPositionTextBox
            // 
            this.CurrentPositionTextBox.Location = new System.Drawing.Point(312, 296);
            this.CurrentPositionTextBox.Name = "CurrentPositionTextBox";
            this.CurrentPositionTextBox.Size = new System.Drawing.Size(152, 20);
            this.CurrentPositionTextBox.TabIndex = 46;
            // 
            // button2
            // 
            this.button2.Location = new System.Drawing.Point(142, 74);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(44, 23);
            this.button2.TabIndex = 47;
            this.button2.Text = "NPID";
            this.button2.UseVisualStyleBackColor = true;
            this.button2.Click += new System.EventHandler(this.button2_Click_1);
            // 
            // CutSection
            // 
            this.CutSection.Enabled = false;
            this.CutSection.Location = new System.Drawing.Point(312, 267);
            this.CutSection.Name = "CutSection";
            this.CutSection.Size = new System.Drawing.Size(75, 23);
            this.CutSection.TabIndex = 48;
            this.CutSection.Text = "Cut";
            this.CutSection.UseVisualStyleBackColor = true;
            this.CutSection.Visible = false;
            // 
            // HextextBox
            // 
            this.HextextBox.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.HextextBox.ForeColor = System.Drawing.SystemColors.HotTrack;
            this.HextextBox.Location = new System.Drawing.Point(639, 12);
            this.HextextBox.Name = "HextextBox";
            this.HextextBox.Size = new System.Drawing.Size(443, 490);
            this.HextextBox.TabIndex = 49;
            this.HextextBox.Text = "";
            // 
            // ErrorTextBox
            // 
            this.ErrorTextBox.Location = new System.Drawing.Point(19, 307);
            this.ErrorTextBox.Name = "ErrorTextBox";
            this.ErrorTextBox.Size = new System.Drawing.Size(157, 139);
            this.ErrorTextBox.TabIndex = 50;
            this.ErrorTextBox.Text = "";
            // 
            // comboBox1
            // 
            this.comboBox1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox1.FormattingEnabled = true;
            this.comboBox1.Items.AddRange(new object[] {
            "29.97 FPS",
            "59.94 FPS"});
            this.comboBox1.Location = new System.Drawing.Point(24, 275);
            this.comboBox1.Name = "comboBox1";
            this.comboBox1.Size = new System.Drawing.Size(57, 21);
            this.comboBox1.TabIndex = 51;
            this.comboBox1.SelectedIndexChanged += new System.EventHandler(this.comboBox1_SelectedIndexChanged);
            // 
            // comboBox2
            // 
            this.comboBox2.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox2.FormattingEnabled = true;
            this.comboBox2.Items.AddRange(new object[] {
            "AC-3",
            "AAC"});
            this.comboBox2.Location = new System.Drawing.Point(103, 275);
            this.comboBox2.Name = "comboBox2";
            this.comboBox2.Size = new System.Drawing.Size(55, 21);
            this.comboBox2.TabIndex = 52;
            this.comboBox2.SelectedIndexChanged += new System.EventHandler(this.comboBox2_SelectedIndexChanged);
            // 
            // info
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.SystemColors.ControlLightLight;
            this.ClientSize = new System.Drawing.Size(1121, 506);
            this.Controls.Add(this.comboBox2);
            this.Controls.Add(this.comboBox1);
            this.Controls.Add(this.ErrorTextBox);
            this.Controls.Add(this.HextextBox);
            this.Controls.Add(this.CutSection);
            this.Controls.Add(this.button2);
            this.Controls.Add(this.CurrentPositionTextBox);
            this.Controls.Add(this.NextPESButton);
            this.Controls.Add(this.PrevPESButton);
            this.Controls.Add(this.PCRTextBox);
            this.Controls.Add(this.PacketLenTextBox);
            this.Controls.Add(this.CountTextBox);
            this.Controls.Add(this.PIDTextBox);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.stats);
            this.Controls.Add(this.t3);
            this.Controls.Add(this.go);
            this.Controls.Add(this.jump);
            this.Controls.Add(this.label12);
            this.Controls.Add(this.write);
            this.Controls.Add(this.pack_tot);
            this.Controls.Add(this.label10);
            this.Controls.Add(this.button3);
            this.Controls.Add(this.t2);
            this.Controls.Add(this.t1);
            this.Controls.Add(this.label9);
            this.Controls.Add(this.label8);
            this.Controls.Add(this.label7);
            this.Controls.Add(this.textBox5);
            this.Controls.Add(this.back);
            this.Controls.Add(this.next);
            this.Controls.Add(this.label6);
            this.Controls.Add(this.label5);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.textBox4);
            this.Controls.Add(this.textBox3);
            this.Controls.Add(this.textBox2);
            this.Controls.Add(this.textBox1);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.pay_len);
            this.Controls.Add(this.pcr_val);
            this.Controls.Add(this.pcr);
            this.Controls.Add(this.ad_len);
            this.Controls.Add(this.cnt);
            this.Controls.Add(this.payload);
            this.Controls.Add(this.ad);
            this.Controls.Add(this.pid);
            this.Controls.Add(this.pes_st);
            this.Controls.Add(this.error);
            this.Controls.Add(this.pack_no);
            this.Controls.Add(this.label1);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.KeyPreview = true;
            this.MaximumSize = new System.Drawing.Size(1280, 700);
            this.MinimumSize = new System.Drawing.Size(568, 304);
            this.Name = "info";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Transport Stream Packets Info";
            this.Load += new System.EventHandler(this.info_Load);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		private void button2_Click(object sender, System.EventArgs e)
		{int x;
			if(pack_nr==0) return;
			if((pack_nr%MyBuffer==0)&&(pack_nr>0))
			{
				file.Position=Convert.ToInt64((pack_nr-MyBuffer)*188);
				x=fill_buffer();
			}
			pack_nr--;
			display_pack();
		}

		private void info_Load(object sender, System.EventArgs e)
		{
		
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			file.Close();
			Dispose(true);
		}

		public void init(string file_name,ts_analyzer my_t)
		{
			my_ts=my_t;
            file = new FileStream(file_name, FileMode.Open);	// Input File Stream
//            FileStream file = new FileStream;
//            file = File.OpenRead(file_name);	// Input File Stream
            int i = 0;
			for(i=0;i<MyBuffer;i++) data[i]=new ts_info();
			f_name=file_name;
			max=file.Length;
			poz=0;
			pack_nr=0;
			nr_packs=max/188;
			pack_tot.Text=nr_packs.ToString();
			i=fill_buffer();
			display_pack();
		}

		public int fill_buffer()
		{
			int i=0,k;
			while((i<MyBuffer)&&(poz<max))
			{
				k=file.Read(rd,0,188);
				poz+=188;
				data[i].copy_ts(rd,188);
				i++;
			}
			return i;
		}

		public void display_pack()
		{
            bit bt = new bit();
			if (data[pack_nr%MyBuffer].pack.data[0]!=71) t1.Text="Invalid DATA";
			else
			{
				pack_no.Text=(pack_nr+1).ToString();
				data[pack_nr%MyBuffer].analyze_pack();
                long whereami = file.Position;
                CurrentPositionTextBox.Text = whereami.ToString();
                System.Text.ASCIIEncoding asciiText = new System.Text.ASCIIEncoding();
                HextextBox.Text = "";
                for (int b = 0; b < 188; b++)
                {
                    if ((b % 16) == 0)
                    {
                        HextextBox.Text += "\r\n";
//                        asciiText += "\r\n";
                    }
                    HextextBox.Text += data[pack_nr % MyBuffer].pack.data[b].ToString("X2") + " ";
//                    asciiText += Convert.ToString (data[pack_nr % MyBuffer].pack.data[b]);                                        
                }
//                HextextBox.Text += "\r\n" + asciiText.GetChars (data[pack_nr % MyBuffer].pack.data,0,188);

/*
                for (int b = 0; b < 188; b++)
                {
                    if ((b % 16) == 0)
                    {
                        HextextBox.Text += "\r\n";
                        //                        asciiText += "\r\n";
                    }
//                    HextextBox.Text = Regex.Replace((char)data[pack_nr % MyBuffer].pack.data[b], @"[\x00-\x1F]", ".");
//                    string TempText = (char)data[pack_nr % MyBuffer].pack.data[b];

                    char TempChar = (char)data[pack_nr % MyBuffer].pack.data[b];
                    string TempChar1 = Regex.Replace(TempChar.ToString(), @"[\x00-\x1f]", ".");
                    HextextBox.Text += TempChar1;
                    //                    asciiText += Convert.ToString (data[pack_nr % MyBuffer].pack.data[b]);                                        
                }
*/
                
                int k = data[pack_nr % MyBuffer].pid;
                if (( k == 0x1011 || k == 0x1100) && data[pack_nr % MyBuffer].pes_st)
                {
                    if (data[pack_nr % MyBuffer].pack.data[4] == 0x0 && data[pack_nr % MyBuffer].pack.data[5] == 0x0 && data[pack_nr % MyBuffer].pack.data[6] == 0x1)
                    {
                        int afield = bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[11],0,1);
                        if (afield == 3 || afield == 1 || afield == 2)
                        {
                            int tmpval = (int)data[pack_nr % MyBuffer].pack.data[13]>>1 & 0x7;
                            PTS33 = tmpval * (long)Math.Pow(2, 30);
                            PTS33 += bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[14], 0, 7) * (long)Math.Pow(2,22);
                            PTS33 += bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[15], 0, 6) * (long)Math.Pow(2,15);
                            PTS33 += bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[16], 0, 7) * (long)Math.Pow(2,7);
                            PTS33 += bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[17], 0, 6);
                            HextextBox.Text += "\r\n -------------\r\n" + "PTS33: " + PTS33.ToString();
                            PTS = Convert.ToDouble(PTS33) / 90000;
                            HextextBox.Text += "  PTS: " + PTS.ToString("F4");

                            if (afield == 3 || afield == 1)
                            {
                                DTS33 = bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[18], 4, 4) * (long)Math.Pow(2,32);
                                DTS33 += bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[18], 5, 5) * (long)Math.Pow(2,31);
                                DTS33 += bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[18], 6, 6) * (long)Math.Pow(2,30);
                                DTS33 += bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[19], 0, 7) * (long)Math.Pow(2,22);
                                DTS33 += bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[20], 0, 6) * (long)Math.Pow(2,15);
                                DTS33 += bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[21], 0, 7) * (long)Math.Pow(2,7);
                                DTS33 += bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[22], 0, 6);
                                DTS = Convert.ToDouble(DTS33) / 90000;
                                HextextBox.Text += "\r\n -------------\r\n" + "DTS33: " + DTS33.ToString();
                                HextextBox.Text += " -- DTS: " + DTS.ToString("F4");
                            }
                        
                        }
                        int p = 23;
                        if (k == 0x1011 && afield == 2)
                        {
                            p = 18;
                        }
                        // read in the video NAL units
//                        int p = Convert.ToInt32(pack_nr % MyBuffer);
                        for (int m = p; m < 185; m++)
                        {
                            if (bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[m], 0, 7) == 0 &&
                                 bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[m + 1], 0, 7) == 0 &&
                                 bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[m + 2], 0, 7) == 1)
                            {
                                int nal_ref_idc = bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[m + 3], 0, 2);
                                int nal_unit_type = bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[m + 3], 3, 7);
                                HextextBox.Text += "\r\nnal_ref_idc=" + nal_ref_idc + " nal_unit_type=" + nal_unit_type;
                                if(nal_unit_type == 5)
                                    HextextBox.Text += "(IDR)";
                                if (nal_unit_type == 5 || nal_unit_type == 1)
                                {
                                    int first_mb = bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[m + 4], 0, 7);
                                    HextextBox.Text += "  " + first_mb.ToString("X2");
                                    string[] SliceModes = { "Unknown","0","0","0","0","P-Frame", "B-Frame", "I-Frame" };
                                    if (first_mb >= 0x80)
                                    {
                                        byte slice_type = data[pack_nr % MyBuffer].pack.data[m + 4];
//                                        HextextBox.Text += "\r\n(SliceType = " + Convert.ToString(slice_type,2) + " )";
                                        HextextBox.Text += "\r\n(SliceType = " + SliceModes[ue(slice_type)] + " )";
                                    }
                                    
                                }
                            }
                        }

                    }
                }
                if (( k == 0x1011) && !data[pack_nr % MyBuffer].pes_st)
                {
                    for (int q = 5; q < 185; q++)
                    {
                        if (bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[q], 0, 7) == 0 &&
                             bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[q + 1], 0, 7) == 0 &&
                             bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[q + 2], 0, 7) == 1)
                        {
                            int nal_ref_idc = bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[q + 3], 0, 2);
                            int nal_unit_type = bt.ret_bit_value(data[pack_nr % MyBuffer].pack.data[q + 3], 3, 7);
                            HextextBox.Text += "\r\nnal_ref_idc=" + nal_ref_idc + " nal_unit_type=" + nal_unit_type;
                        }
                    }
                }
                int counter = data[pack_nr % MyBuffer].count;
                CountTextBox.Text = counter.ToString("D");
                PIDTextBox.Text = k.ToString("X4");
                int PacketLength = data[pack_nr % MyBuffer].Pay_len;
                PacketLenTextBox.Text = PacketLength.ToString("D");
                double PCRTime = data[pack_nr % MyBuffer].PCR;
                PCRTextBox.Text = PCRTime.ToString("N3");
                t1.Text="";
				t2.Text="";
				t3.Text="";
				if (data[pack_nr%MyBuffer].error) error.BackColor=Color.Lime;
				else error.BackColor=Color.Magenta;
				if (data[pack_nr%MyBuffer].pes_st) pes_st.BackColor=Color.Lime;
				else pes_st.BackColor=Color.Magenta;
				pid.BackColor=Color.Aqua;
				if (data[pack_nr%MyBuffer].AF) {ad.BackColor=Color.Lime;ad_len.BackColor=Color.Aqua;}
				else {ad.BackColor=Color.Magenta;ad_len.BackColor=Color.Silver;}
				if (data[pack_nr%MyBuffer].Pay) payload.BackColor=Color.Lime;
				else payload.BackColor=Color.Magenta;
				cnt.BackColor=Color.Aqua;
				if (data[pack_nr%MyBuffer].has_PCR) 
				{
					pcr.BackColor=Color.Lime;
					pcr_val.BackColor=Color.Aqua;}
				else {pcr.BackColor=Color.Magenta;pcr_val.BackColor=Color.Silver;}
				pay_len.BackColor=Color.Yellow;
			}
		}

        private int ue(byte exp_golomb)
        {
            int cmp = 0x80;
            int mb = exp_golomb<<1;
            bit mybit = new bit();
            byte ep = exp_golomb;
            int ret;
            for (int i = 0; i < 8; i++)
            {
                if (((mb << i) & cmp) == cmp)
                {
                    if (i == 0)
                        return (0);
                    else
                    {
                        ret = mybit.ret_bit_value(exp_golomb, i, i + i+1) - 1;
                        return (ret);
                    }
                }
            }
            return (0);

            if( !mybit.ret_bit(ep,1) && !mybit.ret_bit(ep,2) && !mybit.ret_bit(ep,3))
            {
                return(7);
            }
            else
            {
                ret = mybit.ret_bit_value(ep,1,5);
                if(ret == 6)
                {
                    return(5);
                }       
                if(ret == 7)
                {
                    return(6);
                }
                else
                {
                    return(0);
                }
            }
        }
        private void see_error(object sender, System.EventArgs e)
		{
			t1.Text="Transport Error Indicator";
			if (data[pack_nr%MyBuffer].error)
			{t2.Text="This packet has errors !";t3.Text="This flag is ON";}
			else
				{t2.Text="This packet has no errors !";t3.Text="This flag is OFF";}
		}

		private void see_pes_st(object sender, System.EventArgs e)
		{
			t1.Text="Payload Unit Start Indicator";
			if (data[pack_nr%MyBuffer].pes_st)
			{t2.Text="PES packet start";t3.Text="This flag is ON";}
			else
			{t2.Text="No PES packet starts here";t3.Text="This flag is OFF";}		
		}

		private void see_pid(object sender, System.EventArgs e)
		{
			int k=data[pack_nr%MyBuffer].pid;
			t1.Text="Transport Stream packet PID";
			t2.Text="Value : "+k.ToString();
			t3.Text="Packet type : ";
			if (k==0) t3.Text+="Program Association Table";
			if (k==1) t3.Text+="Conditional Access Table";
			if ((k>1)&&(k<16)) t3.Text+="Reserved PID - Illegal packet";
			if ((k>15)&&(k<8191)) t3.Text+="Normal packet";
            if (k == 8191) t3.Text += "Null packet";
		}

		private void see_ad(object sender, System.EventArgs e)
		{
			t1.Text="Adaptation Field Control";
			if (data[pack_nr%MyBuffer].AF)
			{t2.Text="Adaptation Field is present";t3.Text="This flag is ON";}
			else
			{t2.Text="No Adaptation Field present here";t3.Text="This flag is OFF";}		
		}

		private void see_pay(object sender, System.EventArgs e)
		{
			t1.Text="Payload Indicator";
			if (data[pack_nr%MyBuffer].Pay)
			{t2.Text="This packet has payload";t3.Text="This flag is ON";}
			else
			{t2.Text="No payload present in this packet";t3.Text="This flag is OFF";}		
		}

		private void see_cnt(object sender, System.EventArgs e)
		{
			t1.Text="Continuity Counter";
			t2.Text="Value : "+data[pack_nr%MyBuffer].count.ToString();
			t3.Text="This field is present in each packet";
		}

		private void see_ad_len(object sender, System.EventArgs e)
		{
			t1.Text="Adaptation Field Length";
			if(data[pack_nr%MyBuffer].AF)
			{t2.Text="Value : "+data[pack_nr%100].Ad_len.ToString();t3.Text="";}
			else{t2.Text="No Adaptation Field present in this packet";t3.Text="";}
		}

		private void see_pcr(object sender, System.EventArgs e)
		{
			t1.Text="PCR Flag ( Program Clock Reference )";
			if (data[pack_nr%MyBuffer].has_PCR)
			{t2.Text="This packet has PCR";t3.Text="This flag is ON";}
			else
			{t2.Text="No PCR field present in this packet";t3.Text="This flag is OFF";}		
		}

		private void see_pcr_val(object sender, System.EventArgs e)
		{
			t1.Text="PCR value ( in miliseconds )";
			if (data[pack_nr%MyBuffer].has_PCR)
			{t2.Text="Value : "+data[pack_nr%MyBuffer].PCR.ToString();
				t3.Text="The time reference for the decoder";}
			else
			{t2.Text="No PCR field present in this packet";t3.Text="";}		

		}

		private void see_pay_len(object sender, System.EventArgs e)
		{
			t1.Text="Payload length ( determined value )";
				if(data[pack_nr%MyBuffer].Pay)
				{
					t2.Text="Value : "+data[pack_nr%MyBuffer].Pay_len.ToString();
					t3.Text="Nr. of bytes carried from the elementary stream";
				}
				else
				{
					t2.Text="No Payload present";
					t3.Text="The packet doesn't contain elementary stream bytes";
				}
		}

		private void next_Click(object sender, System.EventArgs e)
		{
            int x;
			if(pack_nr>=nr_packs-1) return;
			if(((pack_nr+1)%MyBuffer==0)&&(pack_nr>0)) x=fill_buffer();
			pack_nr++;
			display_pack();
		}

        private void NextPESButton_Click(object sender, EventArgs e)
        {
            int x;
            if (pack_nr >= nr_packs - 1) return;

 
            while (pack_nr < nr_packs -1)
            {    
                if (((pack_nr + 1) % MyBuffer == 0) && (pack_nr > 0))
                    x = fill_buffer();
                pack_nr++;
                data[pack_nr % MyBuffer].analyze_pack();
                if (data[pack_nr % MyBuffer].pes_st)
                    break;
            }
            display_pack();

        }


        private void PrevPESButton_Click(object sender, EventArgs e)
        {
            int x;
            if (pack_nr == 0) return;
            while (pack_nr > 0)
            {
                if ((pack_nr % MyBuffer == 0) && (pack_nr > 0))
                {
                    file.Position = Convert.ToInt64((pack_nr - MyBuffer) * 188);
                    x = fill_buffer();
                }
                pack_nr--;
                if (pack_nr == 0)
                    return;
                data[pack_nr % MyBuffer].analyze_pack();
                if (data[pack_nr % MyBuffer].pes_st)
                    break;
            }
            display_pack();
            
            }

        // NPID Next PES start with the same PID
        private void button2_Click_1(object sender, EventArgs e)
        {
            int x;
            if (pack_nr >= nr_packs - 1) return;

            int current_pid = data[pack_nr % MyBuffer].pid;
            while (pack_nr < nr_packs - 1)
            {
                if (((pack_nr + 1) % MyBuffer == 0) && (pack_nr > 0))
                    x = fill_buffer();
                pack_nr++;
                data[pack_nr % MyBuffer].analyze_pack();
                if (data[pack_nr % MyBuffer].pes_st)
                    if(data[pack_nr % MyBuffer].pid == current_pid)
                        break;
            }
            display_pack();

        }

		private void go_Click(object sender, System.EventArgs e)
		{
            long dest;
            try { dest = Convert.ToInt64(jump.Text) - 1; }
            catch { dest = 1; }
			if ((dest>nr_packs)||(dest<0))
			{t1.Text="Invalid value";t2.Text="";t3.Text="";return;}
			file.Position=(dest-dest%MyBuffer)*188;
			int x=fill_buffer();
			pack_nr=dest;
			display_pack();
		}

		private void restrict()
		{
			next.Enabled=false;
			back.Enabled=false;
			write.Enabled=false;
			go.Enabled=false;
			button3.Enabled=false;
			stats.Enabled=false;
		}

		private void allow()
		{
			next.Enabled=true;
			back.Enabled=true;
			write.Enabled=true;
			go.Enabled=true;
			button3.Enabled=true;
			stats.Enabled=true;
		}

		private void write_Click(object sender, System.EventArgs e)
		{
            bool need_ac3_unit = true;
			int [] vpos = new int[50];
            int [] apos = new int[50];
            int vndx = 0;
            int andx = 0;
            int vfrm = 0;
            int aunit = 0;
            int lastcount = 0;
            long save;
            int cnt = 0;
			int x,i,p;
			bool stop;
            string MyCut = Path.Combine(Path.GetDirectoryName(f_name), "MyCut.ts");
            string AC3Cut = Path.Combine(Path.GetDirectoryName(f_name), "MyAC3." + audio_extension);
            string MyTSInfo = Path.Combine(Path.GetDirectoryName(f_name), "tsinfo.txt");
            StreamWriter f = new StreamWriter(MyTSInfo);
            double AC3_PTS=0.0;
            double Vid_PTS=0.0;
            bit bt = new bit();
            //            FileStream cut_ts = new FileStream(MyCut, FileMode.Create);
            FileStream new_ac3 = new FileStream(AC3Cut, FileMode.Create);
            t1.Text = "Processing....";
			t2.Text="Please wait...";
			t3.Text="";
			restrict();
			this.Refresh();
			f.WriteLine("Transport Stream : "+file.Name);
			f.WriteLine("File size is : "+max.ToString());
			f.WriteLine("Estimated number of packets : "+nr_packs.ToString());
			f.WriteLine("************************************************************************");
			f.WriteLine("");
			save=pack_nr;
			pack_nr=1;
			poz=0;
			file.Position=0;
			x=fill_buffer();
			stop=false;
			while(!stop)
			{
			for(i=0;i<x;i++)
			{
//				f.WriteLine("Packet no. : "+pack_nr.ToString());
				data[i].analyze_pack();
				if (data[i].pack.data[0]!=71)
				{
					f.WriteLine("Error ... Sync byte not found ... Illegal stream format");
					stop=true;
					pack_nr--;
					display_pack();
					pack_nr++;
					t1.Text="File tsinfo.txt created in program directory";
					t3.Text=pack_nr.ToString()+"  packets written ok";
					f.Close();
                    FileStream f1 = new FileStream(MyTSInfo, FileMode.Open);
					t2.Text="File size is  "+f1.Length.ToString()+" bytes";
					f1.Close();
					allow();
					return;
				}
				else
                {

                                       
                                    int k = data[i].pid;
                                    if (data[i].pid == 0x001F)
                                    {
                                        if (lastcount != (data[i].count))
                                        {
                                            vpos[vndx] = vfrm;
                                            vndx++;
                                            ErrorTextBox.Text += "Frame discon: " + vfrm.ToString() + "\r\n";
                                            ac3_total += .100; // Discontinuities create a -100ms delay, so compensate for it here
                                            //                            ac3_total += ac3;
                                        }
                                        if (data[i].count == 15)
                                            lastcount = 0;
                                        else
                                            lastcount = data[i].count + 1;
                                    }
                                    if ((k == 0x1011 || k == 0x1100) && data[i].pes_st)
                                    {
                                        if (data[i].pack.data[4] == 0x0 && data[i].pack.data[5] == 0x0 && data[i].pack.data[6] == 0x1)
                                        {
                                            int afield = bt.ret_bit_value(data[i].pack.data[11], 0, 1);
                                            if (afield == 3 || afield == 1 || afield == 2)
                                            {
                                                int tmpval = (int)data[i].pack.data[13] >> 1 & 0x7;
                                                PTS33 = tmpval * (long)Math.Pow(2, 30);
                                                PTS33 += bt.ret_bit_value(data[i].pack.data[14], 0, 7) * (long)Math.Pow(2, 22);
                                                PTS33 += bt.ret_bit_value(data[i].pack.data[15], 0, 6) * (long)Math.Pow(2, 15);
                                                PTS33 += bt.ret_bit_value(data[i].pack.data[16], 0, 7) * (long)Math.Pow(2, 7);
                                                PTS33 += bt.ret_bit_value(data[i].pack.data[17], 0, 6);
                                                //HextextBox.Text += "\r\n -------------\r\n" + "PTS33: " + PTS33.ToString();
                                                PTS = Convert.ToDouble(PTS33) / 90000;
                                                //HextextBox.Text += "  PTS: " + PTS.ToString("F4");
                                            }
                                        }
                                    }
                    
                    
                                        
                                        if(data[i].pid == 0x1011 && data[i].pes_st)
                                        {                       
                                           if(vfrm == 0)
                                           {
                                                Vid_PTS = PTS;
                                                ErrorTextBox.Text += ((AC3_PTS - Vid_PTS) * 1000.0).ToString("F0") + " ms Delay\r\n";
                                           }
                                           vfrm++;
                                           fps30_total += fps30;
                                           string framestats = vfrm.ToString("D6") + " -- " + (fps30_total - ac3_total).ToString("F3") + " -- " + (fps30_total - ac3_total - ac3_adjusted).ToString("F3") + " -- " + ((vfrm * fps30).ToString("F1"));
                                            //                       if(vfrm < 10000)
                                                f.WriteLine(framestats);
                                        }
                                        if (data[i].pid == 0x1100 && need_ac3_unit)
                                        {
                                            AC3_PTS = PTS;
                                            ac3_unit[cnt] = new ts_info();
                                            ac3_unit[cnt].copy_ts(data[i].pack.data, 188);
                                            ac3_unit[cnt].Ad_len = data[i].Ad_len;
                                            ac3_unit[cnt].Pay_len = data[i].Pay_len;
                                            if (data[i].pes_st)
                                            {
                    //                            ac3_unit[cnt].Ad_len = 20;
                                                ac3_unit[cnt].Pay_len -= 17;
                                            }
                                            cnt++;
                                            if (data[i].AF == true)
                                                need_ac3_unit = false;
                                        }
                                        if (data[i].pid == 0x1100 && data[i].pes_st)
                                        {
                                            aunit++;
                                            ac3_total += ac3;
                                            if ((fps30_total - (ac3_total + ac3_adjusted)) > .024)
                                            {
                                                ac3_adjusted += ac3;
                                                for (int ac3_count = 0; ac3_count < cnt; ac3_count++)
                                                {
                    //                                cut_ts.Write(ac3_unit[ac3_count].pack.data, 0, 188);
                                                    new_ac3.Write(ac3_unit[ac3_count].pack.data, 188 - ac3_unit[ac3_count].Pay_len, ac3_unit[ac3_count].Pay_len);
                                                }
                                                ErrorTextBox.Text += "Ac3 Adjustment: " + ac3_adjusted.ToString("F3") + "\r\n";
                                            }
                                        }
                                        if (data[i].pid == 0x1100)
                                        {
                                            if (data[i].pes_st)
                                                new_ac3.Write(data[i].pack.data, 188 - data[i].Pay_len + 17, data[i].Pay_len - 17);
                                            else
                                                new_ac3.Write(data[i].pack.data, 188 - data[i].Pay_len, data[i].Pay_len);
                                        }

                    //                    if ((data[i].pid == 0x1011) && vfrm > 10)
                    //                        ;
                    //                    else
                                        //cut_ts.Write(data[i].pack.data, 0, 188);

                                        /*                f.Write("Transport Error Indicator :");
                                    if (data[i].error) f.WriteLine("\tON");
                                    else f.WriteLine("\tOFF");
                                    f.Write("Payload Unit Start Indicator :");
                                    if (data[i].pes_st) f.WriteLine("\tON");
                                    else f.WriteLine("\tOFF");
                                    p=data[i].pid;
                                    f.WriteLine("Packet PID Value :\t\t"+p.ToString());
                                    f.Write("Type (depending on PID) :\t");
                                    if(p==0) f.WriteLine("Program Association Table");
                                    if(p==1) f.WriteLine("Conditional Access Table");
                                    if((p>1)&&(p<16)) f.WriteLine("Reserved");
                                    if((p>15)&&(p<8191)) f.WriteLine("Normal packet");
                                    if(p==8191) f.WriteLine("Null packet");
                                    f.WriteLine("Continuity Counter value :\t"+data[i].count.ToString());
                                    if(data[i].AF)
                                    {
                                        f.WriteLine("Adaptation Field Length value :\t"+data[i].Ad_len.ToString());
                                        if(data[i].has_PCR) f.WriteLine("PCR Value :\t"+data[i].PCR.ToString()+" ms");
                                    }
                                    if(data[i].Pay) f.WriteLine("Payload Size :\t"+data[i].Pay_len.ToString());
                                    f.WriteLine("");
                    */
                    pack_nr++;}
			}
				if (x<MyBuffer) stop=true;
				else x=fill_buffer();
			}
			pack_nr-=2;
			display_pack();
			pack_nr++;
			t1.Text="File tsinfo.txt created in program directory";
			t3.Text=pack_nr.ToString()+"  packets written ok";
			f.Close();
//            cut_ts.Close();
            new_ac3.Close();
            FileStream f2 = new FileStream(MyTSInfo, FileMode.Open);
			t2.Text="File size is  "+f2.Length.ToString()+" bytes";
			f2.Close();
			allow();
		}

        private void stats_Click(object sender, System.EventArgs e)
        {
            int x, i, j;
            bool stop, found;
            int vframes = 0;
            int aunits = 0;
            StreamWriter f = new StreamWriter("./ts_stats.txt");
            FileStream cut_ts = new FileStream(@"G:/Junk/Sanctuary/1x04/MyCut.ts", FileMode.Create);
            int nr_str;
            int[] pids = new int[200];
            pcr_stat st, el, ant;

            t1.Text = "Processing statistics....";
            t2.Text = "Please wait...";
            t3.Text = "";
            restrict();
            this.Refresh();
            f.WriteLine("Transport Stream : " + file.Name);
            f.WriteLine("File size is : " + max.ToString());
            f.WriteLine("Estimated number of packets : " + nr_packs.ToString());
            f.WriteLine("************************************************************************");
            f.WriteLine("");
            pack_nr = 1;
            poz = 0;
            file.Position = 0;
            x = fill_buffer();
            stop = false;
            st = new pcr_stat();
            st.next = null;
            ant = st;
            nr_str = 0;
            while (!stop)
            {
                for (i = 0; i < x; i++)
                {
                    data[i].analyze_pack();
                    if (data[i].pack.data[0] != 71)
                    {
                        f.WriteLine("Error ... Sync byte not found ... Illegal stream format");
                        stop = true;
                        pack_nr--;
                        display_pack();
                        pack_nr++;
                        t1.Text = "File ts_stats.txt created in program directory";
                        t3.Text = "Errors found...stats could not be completed";
                        f.Close();
                        FileStream f1 = new FileStream("./ts_stats.txt", FileMode.Open);
                        t2.Text = "File size is  " + f1.Length.ToString() + " bytes";
                        f1.Close();
                        allow();
                        return;
                    }
  
                    else
                    {
                        if (data[i].pes_st)
                        {
                            if (data[i].pid == 0x1011)
                            {
                                vframes++;
                            }
                            if (data[i].pid == 0x1100)
                                aunits++;
                        }
//                        if (pack_nr < 6260 || pack_nr >= 11015)
                        if( ((vframes > 0) && (vframes < 6013)) || ((vframes >= 12029) && (vframes < 29309)) || ((vframes >= 34301) && (vframes < 43901))
                             || ((vframes >= 49277) && (vframes < 61565)) || ((vframes >= 65288) && (vframes < 75272)) || ((vframes > 81416)) )
                        {
//                            int loop;
//                            for (loop = 0; loop < 188; loop++)
                                cut_ts.Write(data[i].pack.data, 0, 188);
                        }


                        if ((data[i].pid > 15) && (data[i].pid < 8191))
                        {
                            found = false;
                            for (j = 1; j <= nr_str; j++)
                                if (pids[j] == data[i].pid) found = true;
                            if (!found)
                            {
                                nr_str++;
                                pids[nr_str] = data[i].pid;
                            }
                        }
                            if (data[i].has_PCR)
                            {
                                el = new pcr_stat();
                                el.pack = pack_nr;
                                el.pid = data[i].pid;
                                el.val = data[i].PCR;
                                ant.next = el;
                                el.next = null;
                                ant = el;
                            }
                            pack_nr++;
                        }
                    }
                    if (x < MyBuffer) stop = true;
                    else x = fill_buffer();
                }
                f.WriteLine("Number of Streams : " + nr_str.ToString() + "\t(diferent PIDs)");
                for (i = 1; i <= nr_str; i++)
                {
                    f.WriteLine("");
                    f.WriteLine("Stream " + i.ToString() + "\tPID = " + pids[i].ToString());
                    f.WriteLine("\tPCR Stamps distribution :");
                    el = st.next;
                    while (el != null)
                    {
                        if (el.pid == pids[i])
                            f.WriteLine("\t\tPack " + el.pack.ToString() + "\tValue = " + el.val.ToString() + " ms");
                        el = el.next;
                    }
                }
                pack_nr -= 2;
                display_pack();
                pack_nr++;
                t1.Text = "File ts_stats.txt created in program directory";
                t3.Text = "Stats were computed ok...";
                f.Close();
                cut_ts.Close();
                FileStream f2 = new FileStream("./ts_stats.txt", FileMode.Open);
                t2.Text = "File size is  " + f2.Length.ToString() + " bytes";
                f2.Close();
                CurrentPositionTextBox.Text = "v="+vframes + "; Aud=" + aunits;
                allow();
        }

		private void button1_Click(object sender, System.EventArgs e)
		{
			FileStream f=new FileStream("./new.ts",FileMode.Create);
			file.Position=0;
			for(int j=1;j<=4;j++)
			{
				fill_buffer();
				for(int i=0;i<MyBuffer;i++)
					f.Write(data[i].pack.data,0,188);
			}
			f.Close();
			t1.Text="File new.ts created";
			t2.Text="";
			t3.Text="";
		}

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBox1.Text == "29.97 FPS")
                fps30 = 1 / (30.0 / 1.001);
            if (comboBox1.Text == "59.94 FPS")
                fps30 = 1 / (60.0 / 1.001);
        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBox2.Text == "AC-3")
            {
                ac3 = .032;
                audio_extension = "ac3";
            }
            if (comboBox2.Text == "AAC")
            {
                ac3 = .02133;
                audio_extension = "aac";
            }
        }

	}

	class pcr_stat
	{
		public double val;
		public int pid;
		public long pack;
		public pcr_stat next;
	}

}

